#!/usr/bin/env python
# -*- coding: CP949 -*-
#
# generated by wxGlade 0.7.2 on Sat Jul 30 12:35:25 2016
#


# Copyright: Kee Hwan Nam, KAIST, Daejeon, Republic of Korea
# email: snowall@kaist.ac.kr / snowall@gmail.com
# This program is licenced under GPL v3
# See https://www.gnu.org/licenses/gpl-3.0.html

# Any bug report or comment is welcomed. Please do not hasitate to contact me.

# This program requires wxPython, numpy, scipy libraries in Python 2.7

# This program calculates optical modes propagating in three-layer optical waveguide.

# version: 0.1
#~ import mpmath as np

#~ np.dps=30
from mode import *
#~ import mpmath
#~ mpmath.dps=30
import time
import multiprocessing
import wx
import os
import psutil
# begin wxGlade: dependencies
import gettext

# end wxGlade
# begin wxGlade: extracode
# end wxGlade
import numpy as np

#~ mpmath.seterr(all='raise')
np.seterr(all='ignore')

import numpy.linalg as linalg
import scipy.special as sp
import scipy.constants
from scipy.special import jv as jv
from scipy.special import yv as yv
from scipy.special import kv as kv
from scipy.special import iv as iv
from scipy.special import jvp as jvp
from scipy.special import yvp as yvp
from scipy.special import kvp as kvp
from scipy.special import ivp as ivp
from scipy.special import jve as jve
from scipy.special import yve as yve
from scipy.special import kve as kve
from scipy.special import ive as ive


#~ jv = lambda n,x:mpmath.autoprec(mpmath.besselj)(n,x)
#~ yv = lambda n,x:mpmath.autoprec(mpmath.bessely)(n,x)
#~ iv = lambda n,x:mpmath.autoprec(mpmath.besseli)(n,x)
#~ kv = lambda n,x:mpmath.autoprec(mpmath.besselk)(n,x)
#~ jvp = lambda n,x:mpmath.autoprec(mpmath.besselj)(n,x,derivative=1)
#~ yvp = lambda n,x:mpmath.autoprec(mpmath.bessely)(n,x,derivative=1)
#~ ivp = lambda n,x:mpmath.autoprec(mpmath.besseli)(n,x,derivative=1)
#~ kvp = lambda n,x:mpmath.autoprec(mpmath.besselk)(n,x,derivative=1)




from scipy.optimize import brentq as rootfind
#~ from mpmath import findroot as rootfind
mu=scipy.constants.mu_0
ep=scipy.constants.epsilon_0
speed=scipy.constants.speed_of_light

		
class main(wx.Frame):
	materials_name=[]
	materials_index=[]
	def __init__(self, *args, **kwds):
		
		# begin wxGlade: main.__init__
		wx.Frame.__init__(self, *args, **kwds)
		self.initialization()
		self.Label_clad1 = wx.StaticText(self, wx.ID_ANY, _("Start radius(um)"))
		self.Text_clad1 = wx.TextCtrl(self, wx.ID_ANY, "20")
		self.Label_clad2 = wx.StaticText(self, wx.ID_ANY, _("Final radius(um)"))
		self.Text_clad2 = wx.TextCtrl(self, wx.ID_ANY, "0.78")
		
		self.Label_core = wx.StaticText(self, wx.ID_ANY, _("Core diameter(um)"))
		self.Text_core = wx.TextCtrl(self, wx.ID_ANY, "8.2")
		self.Label_wavelength = wx.StaticText(self, wx.ID_ANY, _("Wavelength(nm)"))
		self.Text_wavelength = wx.TextCtrl(self, wx.ID_ANY, "532")
		self.Label_core_material = wx.StaticText(self, wx.ID_ANY, _("Core material"))
		self.Box_core_material = wx.ComboBox(self, wx.ID_ANY, choices=self.materials_name, style=wx.CB_READONLY)
		self.Label_clad_material = wx.StaticText(self, wx.ID_ANY, _("Clad. material"))
		self.Box_clad_material = wx.ComboBox(self, wx.ID_ANY, choices=self.materials_name, style=wx.CB_READONLY)
		self.Label_air_material = wx.StaticText(self, wx.ID_ANY, _("Air material"))
		self.Box_air_material = wx.ComboBox(self, wx.ID_ANY, choices=self.materials_name, style=wx.CB_READONLY)
		self.Label_radial_mode = wx.StaticText(self, wx.ID_ANY, _("Radial mode number"))
		self.Text_radial_mode = wx.TextCtrl(self, wx.ID_ANY, "1")
		self.Label_step_size = wx.StaticText(self, wx.ID_ANY, _("Step size"))
		self.Text_step_size = wx.TextCtrl(self, wx.ID_ANY, "0.001")							
		self.Label_mode_rdstep = wx.StaticText(self,wx.ID_ANY, _("Radius steps"))
		self.Text_mode_rdstep = wx.TextCtrl(self, wx.ID_ANY, "10")
		self.Label_mode_limit = wx.StaticText(self,wx.ID_ANY, _("Max azimuthal mode"))
		self.Text_mode_limit = wx.TextCtrl(self, wx.ID_ANY, "4")
		self.Button_execute = wx.Button(self, wx.ID_ANY, _("Execute"))
		self.Button_graph = wx.Button(self, wx.ID_ANY, _("Graph"))
		self.Button_save_graph = wx.Button(self, wx.ID_ANY, _("Save graph"))
		self.Button_quit = wx.Button(self, wx.ID_ANY, _("Quit"))
		self.Box_core_material.Selection=1
		self.Box_clad_material.Selection=0
		self.Box_air_material.Selection=2
		self.Button_execute.Bind(wx.EVT_BUTTON, self.execute)
		self.Button_quit.Bind(wx.EVT_BUTTON, self.quitbtn)
		self.__set_properties()
		self.__do_layout()
		# end wxGlade

	def __set_properties(self):
		# begin wxGlade: main.__set_properties
		self.SetTitle(_("Radius"))
		# end wxGlade

	def __do_layout(self):
		# begin wxGlade: main.__do_layout
		sizer_1 = wx.BoxSizer(wx.VERTICAL)
		sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
		grid_sizer_1 = wx.GridSizer(11, 2, 0, 0)
		grid_sizer_1.Add(self.Label_clad1, 0, 0, 0)
		grid_sizer_1.Add(self.Text_clad1, 0, 0, 0)
		grid_sizer_1.Add(self.Label_clad2, 0, 0, 0)
		grid_sizer_1.Add(self.Text_clad2, 0, 0, 0)
		grid_sizer_1.Add(self.Label_core, 0, 0, 0)
		grid_sizer_1.Add(self.Text_core, 0, 0, 0)
		grid_sizer_1.Add(self.Label_wavelength, 0, 0, 0)
		grid_sizer_1.Add(self.Text_wavelength, 0, 0, 0)
		grid_sizer_1.Add(self.Label_core_material, 0, 0, 0)
		grid_sizer_1.Add(self.Box_core_material, 0, 0, 0)
		grid_sizer_1.Add(self.Label_clad_material, 0, 0, 0)
		grid_sizer_1.Add(self.Box_clad_material, 0, 0, 0)
		grid_sizer_1.Add(self.Label_air_material, 0, 0, 0)
		grid_sizer_1.Add(self.Box_air_material, 0, 0, 0)
		grid_sizer_1.Add(self.Label_radial_mode, 0, 0, 0)
		grid_sizer_1.Add(self.Text_radial_mode, 0, 0, 0)
		grid_sizer_1.Add(self.Label_step_size, 0, 0, 0)
		grid_sizer_1.Add(self.Text_step_size, 0, 0, 0)
		grid_sizer_1.Add(self.Label_mode_limit,0,0,0)
		grid_sizer_1.Add(self.Text_mode_limit,0,0,0)
		grid_sizer_1.Add(self.Label_mode_rdstep,0,0,0)
		grid_sizer_1.Add(self.Text_mode_rdstep,0,0,0)
		sizer_1.Add(grid_sizer_1, 1, 0, 0)
		sizer_2.Add(self.Button_execute, 0, 0, 0)
		sizer_2.Add(self.Button_graph, 0, 0, 0)
		sizer_2.Add(self.Button_save_graph, 0, 0, 0)
		sizer_2.Add(self.Button_quit, 0, 0, 0)
		sizer_1.Add(sizer_2, 1, 0, 0)
		self.SetSizer(sizer_1)
		sizer_1.Fit(self)
		self.Layout()
		# end wxGlade
	def initialization(self):
		self.load_materials()

	def load_materials(self):
		d=0
		for f in os.listdir(os.getcwd()):
			if f.split(".")[-1]=="index":
				d=open(f,"r")
				self.materials_name+=[d.readline()[:-1]]
				tmps=d.readline()
				self.materials_index+=[tmps]
				d.close()
		return 0
	
	def execute(self, event):
		inittime=time.time()
		mm=multiprocessing.Manager()
		processes=[]
		finished=mm.list()
		radialmodes=mm.list()
		materials=mm.dict()
		
		materials['core']=self.materials_index[self.Box_core_material.GetCurrentSelection()]
		materials['clad']=self.materials_index[self.Box_clad_material.GetCurrentSelection()]
		materials['air']=self.materials_index[self.Box_air_material.GetCurrentSelection()]
		mode1=(self.Text_radial_mode.GetValue()).split(",")
		mode2=[]
		rd_start=float(self.Text_clad1.GetValue())
		rd_final=float(self.Text_clad2.GetValue())
		rd_step=(rd_start-rd_final)/float(self.Text_mode_rdstep.GetValue())
		coreclad=float(self.Text_core.GetValue())/rd_start
		for i in mode1:
			t=i.split("-")
			if len(t)==1:
				mode2+=[int(i)]
			else:
				for j in range(int(t[0]),int(t[1])+1):
					mode2+=[j]
		print "In progress...\n"

		for j in mode2:
			for rdtmp in np.arange(rd_final,rd_start,rd_step):
				modeprocess=mode(radialmodes,finished,materials,
					r1=float(self.Text_core.GetValue())*coreclad,
					r2=rdtmp,
					wavelength=float(self.Text_wavelength.GetValue()),
					mode_number=j,
					step=self.Text_step_size.GetValue(),
					limit=self.Text_mode_limit.GetValue()
					)
				modeprocess.daemon=True
				processes.append(modeprocess)
		processNo=len(processes)
		while len(processes):
			if processNo-len(finished)-len(processes)<psutil.cpu_count():
				processes.pop().start()
				print "processed units:", str(len(finished))+"/"+str(processNo),"still in progress..."
			else:
				time.sleep(0.1)
		while True:
			if processNo==len(finished):
				modelist={}
				gplfile=open("dataplot.gpl","w")
				gplfile.writelines("plot ")
				radialmodes.sort()
				print "Result writing..."
				for i in radialmodes:
					for k in i[2]:
						try:
							(modelist.get(k[0])).writelines(str(i[0])+"\t"+str(i[1])+"\t"+str(k[1])+"\n")
						except:
							modelist[k[0]]=open(k[0]+".txt","w")
							gplfile.writelines("\""+k[0]+".txt\" using 2*($2):3 w l,")
							(modelist.get(k[0])).writelines(str(i[0])+"\t"+str(i[1])+"\t"+str(k[1])+"\n")
				print "Calculate Finished\n"
				print "Elapsed time: "+str(time.time()-inittime)+" sec."
				break
			else:
				print "processed units:", str(len(finished))+"/"+str(processNo),"still in progress..."
				time.sleep(1)
	def quitbtn(self,event):
		self.Close()
		
# end of class main

class myGraph(wx.MDIChildFrame):
	def __init__(self, *args, **kwds):
		# begin wxGlade: myGraph.__init__
		wx.MDIChildFrame.__init__(self, *args, **kwds)

		self.__set_properties()
		self.__do_layout()
		# end wxGlade

	def __set_properties(self):
		# begin wxGlade: myGraph.__set_properties
		self.SetTitle(_("frame_2"))
		# end wxGlade

	def __do_layout(self):
		# begin wxGlade: myGraph.__do_layout
		sizer_3 = wx.BoxSizer(wx.VERTICAL)
		self.SetSizer(sizer_3)
		sizer_3.Fit(self)
		self.Layout()
		# end wxGlade

# end of class myGraph
class MyApp(wx.App):
	def OnInit(self):
		mainframe = main(None, wx.ID_ANY, "")
		self.SetTopWindow(mainframe)
		mainframe.Show()
		return True

# end of class MyApp

if __name__ == "__main__":
	gettext.install("app") # replace with the appropriate catalog name
	app = MyApp(0)
	app.MainLoop()

